Index: tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/ConcordanceAnnotations.java
===================================================================
--- tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/ConcordanceAnnotations.java	(revision 0)
+++ tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/ConcordanceAnnotations.java	(revision 517)
@@ -0,0 +1,225 @@
+package org.txm.annotation.rcp.concordance;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+
+import org.txm.annotation.core.Annotation;
+import org.txm.annotation.core.AnnotationManager;
+import org.txm.annotation.core.KRAnnotationEngine;
+import org.txm.annotation.core.repository.AnnotationType;
+import org.txm.annotation.core.repository.TypedValue;
+import org.txm.concordance.core.functions.Concordance;
+import org.txm.concordance.core.functions.Line;
+import org.txm.concordance.core.messages.ConcordanceMessages;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.searchengine.cqp.serverException.CqiServerError;
+import org.txm.utils.logger.Log;
+
+public class ConcordanceAnnotations {
+	
+	Concordance concordance;
+	
+	private AnnotationType viewAnnotation;
+	
+	public ConcordanceAnnotations(Concordance concordance) {
+		
+	}
+	
+	private boolean overlapAnnotation;
+
+	private ArrayList<AnnotationLine> lines;
+
+	private List<Line> concordanceLines;
+	public void setAnnotationOverlap(boolean overlap) {
+		overlapAnnotation = overlap;
+	}
+	public boolean getAnnotationOverlap() {
+		return overlapAnnotation;
+	}
+	
+	public List<AnnotationLine> getLines(int from, int to) throws CqiClientException, IOException, CqiServerError {
+
+		concordanceLines = concordance.getLines(from, to);
+		ArrayList<Match> matches = new ArrayList<Match>();
+		for (Line line : concordanceLines) matches.add(line.getMatch());
+		
+		List<Annotation> ann = getAnnotationForMatches(matches, overlapAnnotation);
+		
+		lines = new ArrayList<AnnotationLine>();
+		
+		for (Annotation a : ann) {
+			AnnotationLine aline = new AnnotationLine(a, getAnnotationTypedValue(a));
+			lines.add(aline);
+		}
+		
+		return lines; // TODO find a way to add 
+	}
+	
+	private String findAnnotationForLine(Match match, List<Annotation> annots, boolean overlap) {
+		String annotationValue = "";
+		if (annots!=null) {
+			if (!annots.isEmpty()) {
+				for (Annotation annot : annots) {
+					if (overlap) {
+						if ((annot.getStart()<=match.getStart() && annot.getEnd()>=match.getEnd()) || (annot.getStart()>match.getStart() && annot.getEnd()<match.getEnd())
+								) {
+							annotationValue = annot.getValue(); 
+							// use the first Annotation found, the one stored in the temporary HSQL database
+							//should be modified to display a list of annotation values corresponding to the match positions (or wrapped if overlap is admitted)
+						}
+					} else {
+						if (annot.getStart()==match.getStart() && annot.getEnd()==match.getEnd()) {
+							annotationValue = annot.getValue(); 
+							// use the first Annotation found, the one stored in the temporary HSQL database
+						}
+					}
+				}
+			}
+		}
+		return annotationValue;
+	}
+	
+	public TypedValue getAnnotationTypedValue(Annotation annotation) { 
+
+		TypedValue annotationValue = null;
+		if (annotation!=null) {
+			annotationValue = viewAnnotation.getTypedValue(annotation.getValue());
+			if (annotationValue == null) { // the annotation is not stored in the KR type -> the annotation is surely built with the CQPAnnotationManager
+				//System.out.println("WARNING: no annotation value found for value id="+annotation.getValue()+" - will be created.");
+				annotationValue = new TypedValue(annotation.getValue(), annotation.getValue(), annotation.getType());
+			}
+		}
+		
+		return annotationValue;
+	}
+
+	public AnnotationType getViewAnnotation(AnnotationType type) {
+		return viewAnnotation;
+	}
+
+
+	private List<Annotation> prepareAnnotationsList(List<Match> matches, List<Annotation> annotations, boolean overlap){
+		List<Annotation> annotsList = new ArrayList<Annotation>();
+
+		int iMatch = 0;
+		int iAnnotation = 0;
+		int nMatch = matches.size();
+		int nAnnotations = annotations.size();
+
+		while (iMatch < nMatch && iAnnotation < nAnnotations) {
+			if (overlap) {
+				if (matches.get(iMatch).getEnd() < annotations.get(iAnnotation).getStart()) {
+					iMatch++;
+					annotsList.add(null); // nothing for this match
+				} else if (annotations.get(iAnnotation).getEnd() < matches.get(iMatch).getStart()) {
+					iAnnotation++;
+				} else {
+					annotsList.add(annotations.get(iAnnotation));
+					iMatch++;
+				}
+			} else {
+				if (matches.get(iMatch).getEnd() < annotations.get(iAnnotation).getStart()) {
+					iMatch++;
+					annotsList.add(null); // nothing for this match
+				} else if (annotations.get(iAnnotation).getEnd() < matches.get(iMatch).getStart()) {
+					iAnnotation++;
+				} else if (annotations.get(iAnnotation).getStart() == matches.get(iMatch).getStart() && 
+						annotations.get(iAnnotation).getEnd() == matches.get(iMatch).getEnd()) {
+					annotsList.add(annotations.get(iAnnotation));
+					iMatch++;
+					iAnnotation++;
+				} else {
+					iAnnotation++;
+				}
+			}
+		}
+
+		while (annotsList.size() < matches.size() ) annotsList.add(null); // fill matches that were not process due to no more annotations
+
+		return annotsList;
+	}
+
+	private HashMap<Match, Annotation> prepareAnnotationsMap(List<Match> matches, List<Annotation> annots, boolean overlap){
+		HashMap<Match, Annotation> annotsList = new HashMap<Match, Annotation>();
+		for (Match m : matches) {
+			boolean hasAnnotations = false;
+			if (annots!=null) {
+				if (!annots.isEmpty()) {
+					for (Annotation annot : annots) {
+						if (overlap){
+							if ((annot.getStart() <= m.getStart() && m.getStart() <= annot.getEnd() && m.getEnd() >= annot.getEnd()) || 
+									(annot.getStart() <= m.getEnd() && m.getEnd() <= annot.getEnd() && m.getStart() <= annot.getStart()) 
+									|| !(annot.getEnd() < m.getStart() || annot.getStart() > m.getEnd())){
+								annotsList.put(m, annot);
+								hasAnnotations = true;
+							}
+						} else {
+							if (annot.getStart()==m.getStart() && annot.getEnd()==m.getEnd()) {
+								annotsList.put(m, annot); 
+								hasAnnotations = true;
+							}
+						}
+					}
+				}
+			}
+			if (!hasAnnotations) {
+				annotsList.put(m, null);
+			}
+		}
+		return annotsList;
+	}
+
+	public List<Annotation> getAnnotationForMatches(List<Match> subsetMatch, boolean overlapAnnotation) {
+		
+		AnnotationManager am = KRAnnotationEngine.getAnnotationManager(concordance.getCorpus());
+		
+		//List<Annotation> allAnnotations = null;
+		List<Annotation> annotationsPerMatch = null;;
+		if (viewAnnotation != null && am != null) {
+			try {
+				annotationsPerMatch = am.getAnnotationsForMatches(viewAnnotation, subsetMatch, overlapAnnotation);
+				//System.out.println("annotationsPerMatch: "+annotationsPerMatch);
+			} catch (Exception e) {
+				System.out.println("Error while reading annotation "+viewAnnotation+" and with "+subsetMatch.size()+" matches");
+				Log.printStackTrace(e);
+			}
+		}
+		return annotationsPerMatch;
+	}
+	
+
+	public void setViewAnnotation(AnnotationType type) {
+		viewAnnotation = type;
+		concordance.resetLines();
+	}
+	
+	/**
+	 * 
+	 * @param i the relative position of the AnnotationLine in the lines list
+	 * 
+	 * @return the AnnotationLine pointed by 'i'. May return null if i is wrong.
+	 */
+	public AnnotationLine getAnnotationLine(Line line) {
+		int i = concordanceLines.indexOf(line);
+		if (i < 0) return null;
+		return getAnnotationLine(i);
+	}
+	
+	/**
+	 * 
+	 * @param i the relative position of the AnnotationLine in the lines list
+	 * 
+	 * @return the AnnotationLine pointed by 'i'. May return null if i is wrong.
+	 */
+	public AnnotationLine getAnnotationLine(int i) {
+		if (lines.size() < i) return null;
+		if (i < 0) return null;
+		
+		return lines.get(i);
+	}
+}

Index: tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/AnnotationLine.java
===================================================================
--- tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/AnnotationLine.java	(revision 0)
+++ tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/AnnotationLine.java	(revision 517)
@@ -0,0 +1,26 @@
+package org.txm.annotation.rcp.concordance;
+
+import org.txm.annotation.core.Annotation;
+import org.txm.annotation.core.repository.TypedValue;
+
+public class AnnotationLine {
+
+	private TypedValue annotationValue;
+
+	private Annotation annotation;
+	
+	public AnnotationLine(Annotation annotation, TypedValue annotationValue) {
+		this.annotation = annotation;
+		this.annotationValue = annotationValue; 
+	}
+	
+
+	public Annotation getAnnotation() {
+		return annotation;
+	}
+	
+
+	public TypedValue getAnnotationValue() {
+		return annotationValue;
+	}
+}

Index: tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/AnnotationLineDecorator.java
===================================================================
--- tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/AnnotationLineDecorator.java	(revision 0)
+++ tmp/org.txm.annotation.rcp/src/org/txm/annotation/rcp/concordance/AnnotationLineDecorator.java	(revision 517)
@@ -0,0 +1,29 @@
+package org.txm.annotation.rcp.concordance;
+
+import org.txm.annotation.core.Annotation;
+import org.txm.concordance.core.functions.LineDecorator;
+
+public class AnnotationLineDecorator extends LineDecorator {
+	ConcordanceAnnotations annotations;
+	
+	public AnnotationLineDecorator(ConcordanceAnnotations annotations) {
+		this.annotations = annotations;
+	}
+	
+	/**
+	 * Add "<" or ">" depending of the current position of the match and the annotation start end positions
+	 */
+	@Override
+	public String decorate(int i, int currentPos, String str) {
+		Annotation annotation = annotations.getAnnotationLine(i).getAnnotation();
+		
+		if (annotation != null) {
+			if (currentPos == annotation.getStart()) {
+				return "< "+str;
+			} else if (currentPos == annotation.getEnd()) {
+				return str+" >";
+			}
+		}
+		return str;
+	}
+}

